
public class SynchronizedMultithreadTest {

	// Synchronized Multithread (using Monitor)
	public static void main(String[] args) {
		System.out.println("Synchronized Multithread start");

		// SynchronizedMultithread extends Thread
		SharedCounter sc = new SharedCounter(0);
		new SynchronizedMultithread("SynchronizedThread1 : ", sc, Thread.MIN_PRIORITY).start();
		new SynchronizedMultithread("SynchronizedThread2 : ", sc, Thread.NORM_PRIORITY).start();
		new SynchronizedMultithread("SynchronizedThread3 : ", sc, Thread.MAX_PRIORITY).start();
		
		// MultithreadRunnable implements Runnable
		SharedCounter sc2 = new SharedCounter(100);
		new Thread(new SynchronizedMultithreadRunnable(sc2), "SynchronizedThreadRunnable1 : ").start();
		new Thread(new SynchronizedMultithreadRunnable(sc2), "SynchronizedThreadRunnable2 : ").start();
		new Thread(new SynchronizedMultithreadRunnable(sc2), "SynchronizedThreadRunnable3 : ").start();
		
		System.out.println("Synchronized Multithread end");
	}
}