// global counter (using monitor)
public class SharedCounter {
	private int count = 0; 
	
	public SharedCounter(int cnt) {
		count = cnt;
	}

	public synchronized int getCount() {
		return count;
	}

	public synchronized void nextCount(int i) { // critical section
		Thread.yield();
		System.out.println(Thread.currentThread().getName() + " cycle=" + i + " global count=" + count);
		count++;
	}
}